%% ------  Lezione3, 17 ottobre 2016 ------ 
% PCA

clear all; % cancella il contenuto di memoria
close all; % cancella tutte le figure presenti nella sessione
clc; % pulisce lo schermo

% Caricare il file "iris.mat":
% dataset di 150 oggetti in uno spazio 4-dimensionale.
load iris.mat

% Capisco quante feature e quanti oggetti ho nel dataset
[D,N] = size(data);


%% PCA
% Calcolare la matrice di trasformazione A utilizzando la Principal
% Component Analysis.
%
% Ridurre la dimensionalita' del dataset a 2 e visualizzarlo
% (visualizzare le varie classi con colori diversi.)

% 1: calcolo la media
mu = mean(data, 2);

% 2: centro i dati
datac = data - repmat(mu, [1 N]);

% 3: calcolo la matrice di covarianza
C = 1/(N-1) * datac*datac';

% 4: calcolo autovalori/autovettori (eigenvalues/eigenvectors)
[V,D] = eig(C);

% 5: ordino gli autovalori
[val, idx] = sort(diag(D), 'descend');

% 6: costruisco la matrice di trasformazione
A = V(:, idx(1:2));

% 7: eseguo la trasformazione
Y = A' * datac;

% 8: scatter plot
scatter(Y(1,:), Y(2,:), [], labels, 'fill');
title('data after PCA')

%%
% Calcolare l'importanza di ogni direzione
%
% Eseguire PCA usando un numero L di componenti
% tali che codifichino il 97% di informazione
% (per il concetto di informazione, si veda la slide 80 
% della slide di teoria sulla rappresentazione).

val_pct = val./sum(val); % trasformo gli autovalori in percentuali

for i = 1:4
    % Guardo quanta informazione ho prendendo i primi i autovalori
    informazione = sum(val_pct(1:i));
    if informazione > 0.97
        break
    end
end

fprintf('Numero ottimale di componenti da scegliere: ')
i

% 
% Plottare gli autovalori e trovare dove la decrescita
% degli autovalori non e' piu' cosi' marcata (Cattel scree test)

figure, plot(val), title('Autovalori ordinati')
% Effettivamente dopo i primi due autovalori la decrescita
% non è più così marcata

    
    
    
    





